Solution
========

Please see [design doc](/src/design.txt) first.

NOTE: The players can ignore the server-side. There is almost no logic there,
and the one that is there is either obvious, or duplicated on the client side.
The Flag is checked fully on the client side.

There are two ways to solve the challenge.

The easy way requires a decent understanding on what is going on anyway, so
it's probably not achievable for the players.

It requires one to wait around 30 seconds into execution, and then do a memory
snapshot. Having the snapshot you can proceed like this:

1. Locate the mmaped regions that are used by all the threads (ignore the main
thread).

2. Analyze them. Ignore the ones that seem to do nothing (there will be a random
number of them).

3. Try to figure out which one does what. There are a couple of pieces to this
puzzle (in general, think of this as a simple FPGA-like VM with no bytecode):
    * There are 4 RAM threads, each with 4 read-write ports (128 cells of
    16-bit words).
    * There are also 4 "Auxiliary Processing Unit" threads, which do simple
    math on data in RAM.
    * There are 3 CPUs.
        * The first CPU takes data from IO and spreads it in 4 RAMs, then it
        starts APUs.
        * The second CPU does some simple math on the data in RAM.
        * The third CPU hashes the data (each word separately) and decides
        whether the input was correct.
    * And one IO ("display") thread that gets the data from the user and
    displays the result.

4. Either reverse or otherwise crack the math that's going on there.

5. Enter the flag, and that's it.

The harder way eventually converges with the easy way, but it requires one to
defeat some anti-debugging mechanisms. This will have to be automated in some
way, as there are a lot of code chunks executed by the client, and they
differ with each execution.

A typical solution would go like this:

1. Find a way to dump all the chunks (wireshark will probably be the easiest
way).

2. Deobfuscate them somehow, i.e. create an automated tool that does it.

3. Analyze them, categorize them. Ignore all the anti-debugging / noise stuff.

4. You're left with the VM - see the 'easy way' for the rest of the steps.

