#pragma once

#define UNUSED (void)

struct api_t {
  // Client API.
  void (*ack)(unsigned char);
  void (*send_to_master)(const void*, int);
  int (*recv_from_master)(void*, int);
  void (*set_finished)(void);

  // Commonly used C functions.
  int (*puts)(const char*);
  int (*printf)(const char*, ...);
  void (*gets)(char*, int);
  void (*flush_stdout)(void);
  void (*abort)(int);  // Actually it's _exit.
  void* (*mmap)(unsigned long, int);  // Simplified.
  void (*msleep)(int);  // Calls usleep with art * 1000.

  // Thread stuff.
  int (*thread_create)(void *thread, void *(*start_routine)(void *), void *arg);

  // Dynamic loader functions.
  void* (*dlsym)(void*, const char*);
  void* (*dlopen)(const char*, int);
  int (*dlclose)(void*);
};

