from obfuscator import *
from glob import glob
import os
import pickle
import sys
import subprocess

# Number of 'encryption' operations (this includes also NOOPs).
ALG_LENGTH = 20  # TODO: change to 20

# Number of variants per file.
VARIANT_NUM = 1000  # TODO: change to 10000

HERE = os.path.dirname(os.path.abspath(__file__))
final = {}

for fn in glob('%s/codes/ch_*.c' % HERE):
  # "/full/path/ch_asdf.c" --> "asdf"
  bn = os.path.splitext(os.path.basename(fn))[0][3:]
  print "--- Processing %s" % bn

  print "Compiling and linking."
  ret = subprocess.check_output([
      "gcc",
      "-Wno-main", "-Wno-discarded-qualifiers",
      "-masm=intel",
      "-pie", "-fpie", "-nostdlib", "-fPIC", "-S",
      "-o", "%s/codes/ch_%s.s" % (HERE, bn),
      "%s/codes/ch_%s.c" % (HERE, bn)
  ])
  if ret:
    print ret

  ret = subprocess.check_output([
      "gcc", "-Wall", "-Wextra",
      "-Wno-main", "-Wno-discarded-qualifiers",
      "-masm=intel",
      "-pie", "-fpie", "-nostdlib", "-fPIC", "-c",
      "-o", "%s/codes/ch_%s.o" % (HERE, bn),
      "%s/codes/ch_%s.c" % (HERE, bn)
  ])
  if ret:
    print ret

  ret = subprocess.check_output([
      "ld",
      # "-pie",  So it seems -pie only works with ELFs...
      "-o", "%s/codes/ch_%s.bin" % (HERE, bn),
      "-T", "%s/codes/linker.lds" % HERE,
      "%s/codes/ch_%s.o" % (HERE, bn)
  ])
  if ret:
    print ret

  print "Obfuscating...",
  sys.stdout.flush()

  d = read_file("%s/codes/ch_%s.bin" % (HERE, bn))

  variants = []
  last_percent = 0
  for i in xrange(VARIANT_NUM):
    output = obfuscate(d, ALG_LENGTH)
    variants.append(str(output))

    curr_percent = ((i + 1) * 100) / VARIANT_NUM
    if curr_percent % 10 == 0 and curr_percent != last_percent:
      last_percent = curr_percent
      print "%i%%..." % curr_percent,
      sys.stdout.flush()

  final[bn] = variants
  print

print "--- Finalizing"

print "Writing chunks.pickle..."
with open("%s/chunks.pickle" % HERE, "wb") as f:
  pickle.dump(final, f)



