# Challenge functions.

# Stage 0.
def precheck(chain_value, challenge):
  return (chain_value * 17 + challenge) & 0xff

# Proof of work.

def proof_of_work1(chain_value, challenge):
  return (challenge - chain_value + 19) & 0xff

def proof_of_work2(chain_value, challenge):
  return (challenge ^ chain_value ^ 19) & 0xff

def proof_of_work3(chain_value, challenge):
  return (challenge * chain_value * 19) & 0xff

def proof_of_work4(chain_value, challenge):
  return ((challenge * 15) ^ chain_value) & 0xff

def proof_of_work5(chain_value, challenge):
  return (challenge - chain_value * 7) & 0xff

# Anti-Debug tricks.

def ptrace(chain_value, challenge):
  return ((challenge % 37) * (chain_value % 39)) & 0xff

def ptrace2(chain_value, challenge):
  return (challenge + 3 * chain_value) & 0xff

def env1(chain_value, challenge):
  return (challenge - 9 * chain_value) & 0xff

def env2(chain_value, challenge):
  return (challenge * 7 * chain_value) & 0xff

def parent1(chain_value, challenge):
  return (challenge ^ chain_value) & 0xff

def libs1(chain_value, challenge):
  return (challenge + 1 + chain_value) & 0xff

def libs2(chain_value, challenge):
  return (challenge ^ 0xff ^ chain_value) & 0xff

def exec1(chain_value, challenge):
  return (challenge & chain_value) & 0xff


def thread_noise(chain_value, challenge):
  return (challenge | chain_value) & 0xff


# Device init stages.
def display(chain_value, challenge):
  return chain_value ^ challenge

def ram(chain_value, challenge):
  return (chain_value + challenge + 99) & 0xff

def apu(chain_value, challenge):
  return (chain_value + challenge * 3) & 0xff

def cpu1(chain_value, challenge):
  return (chain_value + challenge * challenge) & 0xff

def cpu2(chain_value, challenge):
  return ((chain_value + challenge) * (chain_value - challenge)) & 0xff

def cpu3(chain_value, challenge):
  return (challenge + 43) & 0xff


# End stages.
def end(chain_value, challenge):
  return (chain_value - challenge) & 0xff

def broken_chain(chain_value, challenge):
  return chain_value

def hard_end(chain_value, challenge):
  return 0

# Other.

def template(chain_value, challenge):
  return (chain_value * challenge) & 0xff

