#include "common_ch.h"
#include "../../common.h"

#define GrFA "\x1b[38;5;232m"
#define GrFB "\x1b[38;5;233m"
#define GrFC "\x1b[38;5;234m"
#define GrFD "\x1b[38;5;235m"
#define GrFE "\x1b[38;5;236m"
#define GrFF "\x1b[38;5;237m"
#define GrFG "\x1b[38;5;238m"
#define GrFH "\x1b[38;5;239m"
#define GrFI "\x1b[38;5;240m"
#define GrFJ "\x1b[38;5;241m"
#define GrFK "\x1b[38;5;242m"
#define GrFL "\x1b[38;5;243m"
#define GrFM "\x1b[38;5;244m"
#define GrFN "\x1b[38;5;245m"
#define GrFO "\x1b[38;5;246m"
#define GrFP "\x1b[38;5;247m"
#define GrFQ "\x1b[38;5;248m"
#define GrFR "\x1b[38;5;249m"
#define GrFS "\x1b[38;5;250m"
#define GrFT "\x1b[38;5;251m"
#define GrFU "\x1b[38;5;252m"
#define GrFV "\x1b[38;5;253m"
#define GrFW "\x1b[38;5;254m"
#define GrFX "\x1b[38;5;255m"

#define GrBA "\x1b[48;5;232m"
#define GrBB "\x1b[48;5;233m"
#define GrBC "\x1b[48;5;234m"
#define GrBD "\x1b[48;5;235m"
#define GrBE "\x1b[48;5;236m"
#define GrBF "\x1b[48;5;237m"
#define GrBG "\x1b[48;5;238m"
#define GrBH "\x1b[48;5;239m"
#define GrBI "\x1b[48;5;240m"
#define GrBJ "\x1b[48;5;241m"
#define GrBK "\x1b[48;5;242m"
#define GrBL "\x1b[48;5;243m"
#define GrBM "\x1b[48;5;244m"
#define GrBN "\x1b[48;5;245m"
#define GrBO "\x1b[48;5;246m"
#define GrBP "\x1b[48;5;247m"
#define GrBQ "\x1b[48;5;248m"
#define GrBR "\x1b[48;5;249m"
#define GrBS "\x1b[48;5;250m"
#define GrBT "\x1b[48;5;251m"
#define GrBU "\x1b[48;5;252m"
#define GrBV "\x1b[48;5;253m"
#define GrBW "\x1b[48;5;254m"
#define GrBX "\x1b[48;5;255m"

#define GrnF "\x1b[38;5;46m"

void worker(volatile struct vm_io_dev_st *dev) {
  struct api_t *api = dev->api;

  api->printf("\x1b[2J\x1b[1;1H");
  api->puts(GrFH "      ____________           ____________           ____________       " );
  api->puts(GrFM "     /            \\         /            \\         /            \\      " );
  api->puts(GrFR "    |  /````````\\  |       |  /````````\\  |       |  /````````\\  |     " );
  api->puts(GrFX "--------        ---------------        ---------------        ---------" );
  api->puts(GrFR "    |  \\________/  |       |  \\________/  |       |  \\________/  |     " );
  api->puts(GrFM "     \\            /         \\            /         \\            /      " );
  api->puts(GrFH "      ````````````           ````````````           ````````````       " );
  api->puts("");
  api->puts(GrFX "                           Chains of Trust                            " );
  api->puts(GrFU "                           - RE Challenge -                           " );
  api->puts(GrFR "                       <"GrnF"Dragon CTF 2018 Teaser"GrFR">                       " );
  api->puts(GrFO "                         by Gynvael Coldwind                          " );
  api->puts("");
  api->puts(GrFO "                             Your answer?                             " );
  api->printf(GrFF "                   ................................\r" );
  api->printf(GrFX "                   " );
  api->flush_stdout();

  api->gets(dev->input_buffer, 33);
  mfence();
  dev->input_ready = true;
  api->puts(GrFO "                   Thank you. Now please wait a sec." );
  api->printf(GrFO "                   " );

  while (!dev->power_off) {
    if (dev->output_ready) {
      api->puts(dev->output_buffer);
      mfence();
      dev->output_ready = false;
    }

    api->msleep(50);
  }
}

// This is a workaround since ld linker cannot do -pie (or more explicitly,
// cannot do lea [rel...]) on non-ELF targets. Ugh.
size_t get_start_address(void) {
  void *ret = __builtin_return_address(0);
  return (size_t)ret & ~0xfffUL;
}

size_t get_end_address(size_t start) {
  size_t p = start;
  for (;; p++) {
    unsigned char *pul = (unsigned char*)p;
    int counter = 0;
    while (*pul == 0x41) {
      pul++;
      counter++;
    }

    if (counter == 8) {
      return p;
    }
  }

  return 0;  // Will never happen.
}

void *get_worker_addr(void);
__asm(
  ".globl get_worker_addr\n"
  "get_worker_addr:\n"
  "  lea rax, worker[rip]\n"
  "  ret\n"
);

void spawn_thread(struct api_t *api, size_t start, size_t end) {
  // Allocate io_dev register set region.
  struct vm_io_dev_st *vm_io_dev = api->mmap(sizeof(struct vm_io_dev_st), PROT_RW);
  vm_io_dev->api = api;
  vm_io_dev->input_ready = false;
  vm_io_dev->output_ready = false;
  vm_io_dev->power_off = false;

  // Send region location to master.
  api->send_to_master(&vm_io_dev, sizeof(void*));

  // Allocate new thread region and copy code there.
  size_t sz = end - start;
  void *new_home = api->mmap(sz, PROT_RWX);

  unsigned char *p_src = (unsigned char*)start;
  unsigned char *p_dst = (unsigned char*)new_home;
  for (size_t i = 0; i < sz; i++, p_src++, p_dst++) {
    *p_dst = *p_src;
  }

  // Spawn new thread.
  size_t diff = (size_t)new_home - start;
  size_t worker_addr = (size_t)get_worker_addr() + diff;

  pthread_t th;
  if (api->thread_create(&th, (void*(*)(void*))worker_addr, vm_io_dev) != 0) {
    api->abort(1);
  }
}

// Standard stuff follows.
__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  size_t start = get_start_address();
  size_t end = get_end_address(start);
  spawn_thread(api, start, end);

  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (chain_value ^ challenge) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

__attribute__((section(".end")))
unsigned long __end_marker = 0x4141414141414141UL;

