#include "common_ch.h"
#include "../../common.h"

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  struct vm_io_dev_st *vm_io_dev;
  if (api->recv_from_master(&vm_io_dev, sizeof(void*)) != sizeof(void*)) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  for (int i = 0; i < 5 /* seconds */ * 8 /* 125ms periods */; i++) {
    if (vm_io_dev->power_off) {
      api->flush_stdout();
      api->set_finished();
      return 0;
    } else {
      api->msleep(125);
    }
  }

  // Usual challenge stuff otherwise.
  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (chain_value - challenge) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

