#include "common_ch.h"
#include "../../common.h"

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  char* (*getenv)(const char *) = api->dlsym(RTLD_DEFAULT, "getenv");

  if (getenv("LD_PRELOAD") != NULL) {
    api->puts("No debugging, go away.");
    api->set_finished();
    return 0;
  }

  if (getenv("PATH") == NULL) {
    api->puts("No debugging, go away.");
    api->set_finished();
    return 0;
  }

  // Usual challenge stuff otherwise.
  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (challenge - 9 * chain_value) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

