#include "common_ch.h"
#include "../../common.h"

bool startswith(const char *haystack, const char *needle) {
  for (;;) {
    if (!*needle) {
      return true;
    }

    if (!*haystack) {
      return false;
    }

    if (*needle != *haystack) {
      return false;
    }

    needle++;
    haystack++;
  }

  return false;
}

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  char ***penviron = api->dlsym(RTLD_DEFAULT, "environ");
  char **environ = *penviron;

  bool path_found = false;
  while (*environ) {
    if (startswith(*environ, "LD_PRELOAD=")) {
      api->puts("No debugging, go away.");
      api->set_finished();
      return 0;
    }

    if (startswith(*environ, "PATH=")) {
      path_found = true;
    }

    environ++;
  }

  if (!path_found) {
    api->puts("No debugging, go away.");
    api->set_finished();
    return 0;
  }

  // Usual challenge stuff otherwise.
  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (challenge * 7 * chain_value) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

