#include "common_ch.h"
#include "../../common.h"

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  char* (*strstr)(const char*, const char*) = api->dlsym(RTLD_DEFAULT, "strstr");
  s64 (*readlink)(const char*, char*, size_t) = api->dlsym(RTLD_DEFAULT, "readlink");
  void* (*fopen)(const char*, const char*) = api->dlsym(RTLD_DEFAULT, "fopen");
  int (*fclose)(void*) = api->dlsym(RTLD_DEFAULT, "fclose");
  char* (*fgets)(char*, int, void*) = api->dlsym(RTLD_DEFAULT, "fgets");

  char exe_path[256] = {0};
  if (readlink("/proc/self/exe", exe_path, 255) == -1) {
    api->puts("I need /proc/ access. Go away.");
    api->set_finished();
    return 0;
  }

  // Replace last / with \0.
  char *p = exe_path + 255;
  while (p >= exe_path) {
    if (*p == '/') {
      *p = '\0';
      break;
    }
    p--;
  }

  void *f = fopen("/proc/self/maps", "rb");
  if (!f) {
    api->puts("I need /proc/ access. Go away.");
    api->set_finished();
    return 0;
  }

  char buf[1024] = {0};
  while (fgets(buf, 1023, f)) {
    if (strstr(buf, "/libc.so.6") != 0 ||
        strstr(buf, "/libpthread.so.0") != 0 ||
        strstr(buf, "/libstdc++.so.6") != 0) {
      if (strstr(buf, exe_path) == 0) {
        api->puts("No debugging, go away.");
        api->set_finished();
        fclose(f);
        return 0;
      }
    }
  }

  fclose(f);

  // Usual challenge stuff otherwise.
  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (challenge + 1 + chain_value) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

