#include "common_ch.h"
#include "../../common.h"

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  int (*getppid)(void) = api->dlsym(RTLD_DEFAULT, "getppid");
  char* (*strstr)(const char*, const char*) = api->dlsym(RTLD_DEFAULT, "strstr");
  int (*sprintf)(char*, const char*, ...) = api->dlsym(RTLD_DEFAULT, "sprintf");
  s64 (*readlink)(const char*, char*, size_t) = api->dlsym(RTLD_DEFAULT, "readlink");

  int ppid = getppid();
  char path[256];
  sprintf(path, "/proc/%i/exe", ppid);

  char fname[256] = {0};
  if (readlink(path, fname, 256) == -1) {
    api->puts("I need /proc/ access. Go away.");
    api->set_finished();
    return 0;
  }

  if (strstr(fname, "/gdb") != NULL) {
    api->puts("No debugging, go away.");
    api->set_finished();
    return 0;
  }

  // Usual challenge stuff otherwise.
  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (challenge ^ chain_value) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

