#include "common_ch.h"
#include "../../common.h"

void worker(struct api_t *api) {
  api->send_to_master("WoRK", 4);

  u32 work;
  int ret = api->recv_from_master(&work, 4);
  if (ret != 4) {
    api->puts("Master disconnected.");
    api->abort(1);
  }

  work ^= 0x9876bd45;

  api->send_to_master(&work, 1);  // Yes, only lowest byte.
}

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  worker(api);

  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (challenge ^ chain_value ^ 19) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

