#include "common_ch.h"
#include "../../common.h"

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  long (*ptrace)(int, int, void*, void*) = api->dlsym(RTLD_DEFAULT, "ptrace");
  int *errno = api->dlsym(RTLD_DEFAULT, "errno");

  // At this stage ptrace was already called, so it MUST failed each time now.
  if (ptrace(0, 0, 0, 0) != -1 || *errno != 1 /* Op not permitted */) {
    api->puts("No debugging, go away.");
    api->set_finished();
    return 0;
  }

  // Usual challenge stuff otherwise.
  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (challenge + 3 * chain_value) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

