#include "../../common.h"

volatile int x = 5;

void worker(struct api_t *api) {
  api->puts("Hello world!");
  api->flush_stdout();

  api->send_to_master("WoRK", 4);

  unsigned char buf[4];
  int ret = api->recv_from_master(buf, 4);
  if (ret != 4) {
    api->puts("Master didn't provide enough work. Good bye.");
    api->flush_stdout();
    api->set_finished();
    return;
  }

  unsigned char res = 0;
  for(int i = 0; i < 4; i++) {
    res += buf[i];
  }

  api->send_to_master(&res, 1);
  api->puts("Sent work to master!");

  api->set_finished();
}

__attribute__((section(".start")))
unsigned char main(struct api_t *api, unsigned char chain_value) {
  worker(api);

  unsigned char challenge;
  if (api->recv_from_master(&challenge, 1) != 1) {
    api->puts("Master disconnected.");
    api->set_finished();
    return 0;
  }

  unsigned char new_chain_value = (chain_value * challenge) & 0xff;
  api->ack(new_chain_value);
  return new_chain_value;
}

