// This file is to be included, not linked.

u16 ram_load(struct api_t *api,
             volatile struct ram_port_st *port, u16 addr) {
  port->data_ready = false;
  port->write_enabled = false;
  port->addr = addr;
  mfence();

  port->addr_ready = true;  // Trigger.
  mfence();

  while (!port->data_ready) {
    api->msleep(1);
  }

  mfence();

  return port->data;
}

void ram_store(struct api_t *api,
               volatile struct ram_port_st *port, u16 addr, u16 data) {
  port->data_ready = false;
  port->write_enabled = true;
  port->addr = addr;
  port->data = data;
  mfence();

  port->addr_ready = true;  // Trigger.
  mfence();

  // Wait for data to be processed.
  while (port->addr_ready) {
    api->msleep(1);
  }
}

void my_strcpy(void *dst, void *src) {
  char *d = dst;
  char *s = src;
  while (*s) {
    *d++ = *s++;
  }
}

